﻿using System;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Tutorial.BackgroundMask
{
    class BackgroundMask
    {
        #region Vars
        private uint[] mTextureData;
        private int mWidth;
        private int mHeight;
        #endregion

        #region Properties
        public Texture2D Texture
        {
            set { this.SetupBackgroundMask(value); }
        }
        #endregion

        #region Constructors
        public BackgroundMask() { }

        public BackgroundMask(Texture2D pTexture)
        {
            this.SetupBackgroundMask(pTexture);
        }
        #endregion

        #region Methods
        private void SetupBackgroundMask(Texture2D pTexture)
        {
            this.mWidth = pTexture.Width;
            this.mHeight = pTexture.Height;
            this.mTextureData = new uint[pTexture.Width * pTexture.Height];
            pTexture.GetData<uint>(this.mTextureData);
        }

        public string GetColor(Vector2 pLocation)
        {
            return this.GetColor((int)pLocation.X, (int)pLocation.Y);
        }

        public string GetColor(int pXCoordinate, int pYCoordinate)
        {
            if ((pXCoordinate >= 0 && pXCoordinate < this.mWidth) && (pYCoordinate >= 0 && pYCoordinate < this.mHeight))
            {
                uint Position = Convert.ToUInt32(pYCoordinate) * Convert.ToUInt32(this.mWidth) + Convert.ToUInt32(pXCoordinate);
                return String.Format("{0:x2}", this.mTextureData[Position]);
            }

            return "ff000000";
        }
        #endregion
    }
}
